global function InitPlayerPingsSys

struct Ping {
	entity sprite
	float time
}

table< entity, array<Ping> > playerPings
const PING_DURATION = 10.0
vector Enemy_Team_Color = OBITUARY_COLOR_ENEMY
bool CoolDown = false
void function InitPlayerPingsSys()
{
	PrecacheSprite($"materials/ui/hud/Enemy_Ping_Animated_Blank.vmt")
	PrecacheSprite($"materials/ui/hud/Normal_Ping_Animated.vmt")
	PrecacheSprite($"materials/ui/hud/Ping_Animated_Full.vmt")
	PrecacheSprite($"materials/ui/hud/Static_Ping_Blank.vmt")
	PrecacheParticleSystem($"P_xo_trail_beam_Custom")
	RegisterSignal( "PingDestroyed" )
	AddCallback_OnClientConnected(OnPlayerConnected)
	AddCallback_OnClientDisconnected(OnPlayerDisconnected)
	
}

void function OnPlayerConnected( entity player )
{
	AddButtonPressedPlayerInputCallback( player, IN_USE, OnUsePing)
	playerPings[ player ] <- []
	
}

void function OnPlayerDisconnected( entity player )
{
    //avoid a crash by removing their pings 
	delete playerPings[player]
}

string function GenerateRGBValueByIndex_( int index )
{
    //if somehow the player was not found in the array of his team it doesnt crash 
	if( index == -1 )
		return "100 100 100"
	
	int[3] RGBValue

    //rotates the columns around for each index
	int changeRGBindex = index % 3

	int potentialNewColour = RGBValue[ changeRGBindex ] + index * 50
	RGBValue[ changeRGBindex ] = potentialNewColour > 255 ? potentialNewColour % 255 : potentialNewColour

    //following column of the first one LOL
	changeRGBindex = (index+1) % 3
	RGBValue[ changeRGBindex ] = 200 // fix value for RGB that constantly roates infront of the changine value
	
	return format( "%i %i %i", RGBValue[0], RGBValue[1], RGBValue[2] )
}


void function OnUsePing( entity player )
{
	thread SpawnPing_( player )
}

bool function isEnemyPing_( entity player, vector newPing )
{	try{
	foreach( Ping p in playerPings[ player ] )
	{
		if (IsValid(p.sprite) && IsAlive( p.sprite )){
		if( Time() - p.time <= 1.0 && LengthSqr( p.sprite.GetOrigin() - newPing ) <= 2000.0 )
		{
			Signal( p, "PingDestroyed" )
			p.sprite.Destroy()
			playerPings[ player ].fastremovebyvalue( p )
			return true
		}
	}}
	}
	catch( error )
	{
		print( "Eval breakpoint error at isEnemyPing_()_PlayerPingSys.nut: " + error + "\n" )
	}
	return false
}

void function SetHighlight_(entity player) {
	foreach ( entity player in GetPlayerArray() )
		Highlight_ClearEnemyHighlight(player)
	Highlight_SetEnemyHighlight( player, "enemy_sonar")
}
void function Wait_()
{
	float waitTime = 5.0
	float currentTime = Time()
	float startTime = currentTime
	float endTime = startTime + waitTime
	while ( endTime > currentTime )
	{

		wait( 0.0 )

		currentTime = Time()
	}
	
		CoolDown = false
	
}



float function GetDistance_(entity client, entity player)
{
	TraceResults trace = TraceLine( client.EyePosition(), player.GetWorldSpaceCenter(), null, TRACE_MASK_BLOCKLOS, TRACE_COLLISION_GROUP_NONE )
	float hDist = Distance(client.EyePosition(), trace.endPos )
	if(hDist == 0)
	{
		return 0.1
	}
	float dDist = hDist * 0.01904 * (4/3)
	return dDist
}

void function SpawnPing_( entity player )
{
	try
	{


	bool if_ent_,valid,player_active = false
	vector offset = < 0, 0, 0 >
	int ping_index = -1
	string current_Player_color = "100 100 100"
	string current_Enemy_color = "255 0 0"

	entity sprite

    //all pings for a player so far
	array<Ping> pings = playerPings[player]
	asset Enemy_Ping_String = $"materials/ui/hud/Enemy_Ping_Animated_Blank.vmt"
	asset Normal_Ping_String = $"materials/ui/hud/Static_Ping_Blank.vmt"
	if(pings.len() >= 3) //spam is not cool
	{	
		Signal( pings[0], "PingDestroyed" )
		if( IsValid( pings[0].sprite ) )
			pings[0].sprite.Destroy()
			playerPings[player] = pings.slice(1)
	
	}
	//Please Dont Ask
	
	TraceResults trace = TraceFromEnt_( player )
  	bool enemyPing = isEnemyPing_( player, trace.endPos ) 
	current_Player_color = GenerateRGBValueByIndex_( GetPlayerArrayOfTeam(  player.GetTeam( ) ).find(player) )

	if (IsValid(trace.hitEnt) && IsAlive( trace.hitEnt )){
		if ( trace.hitEnt.IsTitan() ){
			if_ent_ = true
			valid = true
			if(trace.hitEnt.GetTeam() != player.GetTeam())
					{
			player_active = true
			enemyPing = true
			ping_index = 1
			

					}else{

			
			ping_index = 2


					}
		
			
		}
		else if (trace.hitEnt.IsPlayer() || trace.hitEnt.IsNPC())
		{	if_ent_ = true
			valid = true
			
				if(trace.hitEnt.GetTeam() != player.GetTeam())
					{
						enemyPing = true
						player_active = true

						ping_index = 0
			
					}else{

						ping_index = 2

					}

					
		}else if (trace.hitEnt.IsWorld()){
			valid = true

		}else if (trace.hitEnt == player){
			//Dunno, return?.
			return
		}
		else
		{
			//Invalid Target Err
			return

		}	
	}
		//How the Different Ping Types/Animations are chosen
	 	Normal_Ping_String = $"materials/ui/hud/Static_Ping_Blank.vmt"
		switch ( ping_index )
	{
		case 0:
		 Enemy_Ping_String = $"materials/ui/hud/Enemy_Ping_Animated_Blank.vmt"
		break
		case 1:
		 Enemy_Ping_String = $"materials/ui/hud/Ping_Animated_Full.vmt"
		break
		case 2:
		 Normal_Ping_String = $"materials/ui/hud/Normal_Ping_Animated.vmt"
		break
		default:
		 Enemy_Ping_String = $"materials/ui/hud/Enemy_Ping_Animated_Blank.vmt"
		break
	}
	sprite = CreateSprite_( trace.endPos + offset, player.EyeAngles(), enemyPing ? Enemy_Ping_String : Normal_Ping_String , enemyPing ? current_Enemy_color :current_Player_color , enemyPing ? 0.5 :0.5 , 5 ) 
	//optional spawn on the origin
	// sprite = CreateSprite( trace.hitEnt.GetOrigin() + offset, player.EyeAngles(), enemyPing ? Enemy_Ping_String : Normal_Ping_String , enemyPing ? "255 0 0" : GenerateRGBValueByIndex( GetPlayerArrayOfTeam(  player.GetTeam( ) ).find(player) ), enemyPing ? 0.6 :0.3 , 5 ) 
	sprite.kv.fade_dist = 990000

	SetTeam( sprite, player.GetTeam())
    //set it so only you can your team can see them
	sprite.kv.VisibilityFlags = ENTITY_VISIBLE_TO_FRIENDLY | ENTITY_VISIBLE_TO_OWNER
    //	
	if (if_ent_ == true || valid == true)
	{
	sprite.SetOwner( player )
    //Makes the ping attach to the object that moves, scrapped in favour for the trail
	//	sprite.SetParent( trace.hitEnt )
	}


	
    //track the time a ping was send
	Ping p
	p.sprite = sprite
	p.time = Time()
	playerPings[player].append( p )
	p.sprite.kv.fade_dist = 990000

	//Cant Ping Too Close to Yourself
	float min_dist  = 150
	float dist = Distance( p.sprite.GetOrigin(), player.GetOrigin() )
	//Distance Calc and Destroy and slice if too close
	if ( dist <= min_dist)
	{	
		
		if( IsValid( p.sprite ) )
		{
			p.sprite.Destroy()
			playerPings[ p.sprite.GetOwner() ].slice( 1 )

		}
	

	}
	//thread Scale_Up_Ping(player.EyeAngles(),p.sprite,player)
    //Ping gets detroyed after a set time
	thread DestroyPingDelayed_( p, PING_DURATION,trace.hitEnt )
	//Create a Trail if a Valid Player Ent was Flagged
	if(player_active == true){
		if(IsValid(p.sprite) && IsAlive(p.sprite)){

			thread Update_Ping_( p, trace.hitEnt ,player)
		}
	}
	}
	catch( error )
	{
		print( "Eval breakpoint error at SpawnPing_()_PlayerPingSys.nut: " + error + "\n" )
	}

}


void function Update_Ping_( Ping p,entity target,entity player)
{	try
	{
	//Check Validity
	
	entity handle 
	//Create Trail
	handle = StartParticleEffectOnEntity_ReturnEntity(target,  GetParticleSystemIndex($"P_xo_trail_beam_Custom") , FX_PATTACH_POINT_FOLLOW, 5 )
	//Assert( handle )
	handle.kv.VisibilityFlags = ENTITY_VISIBLE_TO_FRIENDLY | ENTITY_VISIBLE_TO_OWNER
	handle.SetOwner( player )

	//Wait
	wait 4	

	//Check Validity
	if(IsValid(handle) && IsAlive(handle) && handle != null)
	{
		//Stop Effects
		EffectStop(handle)
	}
		
	
	

}

catch( error )
	{
		print( "Eval breakpoint error at Update_Ping_()_PlayerPingSys.nut: " + error + "\n" )
	}
}
// Create a 2D sprite at position
entity function CreateSprite_( vector origin, vector angles, asset sprite, string lightcolor = "255 0 0", float scale = 0.5, int rendermode = 10 )
{
	// Attach a light so we can see it
	entity env_sprite = CreateEntity( "env_sprite" )
	env_sprite.SetScriptName( UniqueString( "molotov_sprite" ) )
	env_sprite.kv.rendermode = rendermode //These do NOT follow any pattern, trial an error is your friend, as you dont have any others anyway (they go from like 1 to 10 or sth, I hontely dont know)
	env_sprite.kv.origin = origin
	env_sprite.kv.angles = angles
	env_sprite.kv.rendercolor = lightcolor
	env_sprite.kv.renderamt = 255
	env_sprite.kv.framerate = "10.0"
	env_sprite.SetValueForModelKey( sprite )
	env_sprite.kv.scale = string( scale )
	env_sprite.kv.spawnflags = 1
	env_sprite.kv.GlowProxySize = 16.0
	env_sprite.kv.HDRColorScale = 1.0
	DispatchSpawn( env_sprite )
	EntFireByHandle( env_sprite, "ShowSprite", "", 0, null, null )

	return env_sprite
}

// Trace to the point an entity looks at
TraceResults function TraceFromEnt_( entity p )
{
	TraceResults traceResults = TraceLineHighDetail( p.EyePosition(),
	p.EyePosition() + p.GetViewVector() * 10000,
	p, TRACE_MASK_SHOT, TRACE_COLLISION_GROUP_NONE )
	return traceResults
}

void function Scale_Up_Ping( vector angles ,entity current_Ping, entity player)
{	float startTime = Time()

	float min_dist  = 200
	//float dist = Distance(current_Ping.GetOrigin(), player.GetOrigin() )
	//Distance Calc and Destroy and slice if too close
	float fade_duration = 10.0
	float rotateTime = 0.5

	while( Time() > 0 )
	{
	
		if(IsValid(current_Ping) && IsAlive(current_Ping) && IsAlive(player)  && current_Ping != null)
	{
		entity mover = CreateExpensiveScriptMover()
		mover.SetOrigin( current_Ping.GetOrigin() )
		mover.SetAngles( current_Ping.GetAngles() )
		current_Ping.SetParent( mover )

		
		mover.NonPhysicsRotateTo( angles, rotateTime, rotateTime*0.2, rotateTime*0.2 )
		printt(angles)
	}
		
		wait( 0.0 )
	}

}
void function Call_Fade_Ping_( Ping p, float fade_duration )
{
	EndSignal( p, "PingDestroyed" )

	float startTime = Time()
	int fade_dist = -1;
	float current_fade_value_from_ent = float(p.sprite.kv.fadedist)
	current_fade_value_from_ent.tofloat()

	while( Time() < startTime + fade_duration && fade_dist != 0)
	{
		float elapsedTime = Time() - startTime
		float alpha = GraphCapped( elapsedTime, 0, fade_duration, current_fade_value_from_ent, 1 )
		p.sprite.kv.fadedist = alpha
		//printt(alpha)
		fade_dist = alpha.tointeger()
		printt("Jumped")

		wait IntervalPerTick()
	}

}
void function DestroyPingDelayed_( Ping p, float ping_duration,entity target )
{
	try{
	EndSignal( p, "PingDestroyed" )
	wait ping_duration
	if( IsValid( p.sprite ) && IsAlive(p.sprite) && p.sprite != null ){
		// Call_Fade_Ping( p, 15 )
		p.sprite.Destroy()
		
		playerPings[ p.sprite.GetOwner() ].slice( 1 )
	}

	}

catch( error )
	{
		print( "Eval breakpoint error at Update_Ping_()_PlayerPingSys.nut: " + error + "\n" )
	}
}